// CAnalysisModuleManager.h: interface for the CAnalysisModuleGraph class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __ANALYSIS_MODULE_MANAGER_H__
#define __ANALYSIS_MODULE_MANAGER_H__

#include "ModuleGraph.h"

#ifdef _LINUX_
#include <sys/types.h>
#include <dirent.h>
#endif

class CAnalysisModuleManager  
{
public:
	CAnalysisModuleManager();
	virtual ~CAnalysisModuleManager();

	bool Initialize ( CAnalysisNotifyInterface* pOwnerInterface , char* pszModuleDir );
	void SetModuleDir ( char* pszModuleDir );

	bool LoadModules();
	void UnloadModules();

	void InsertModuleIntoGraph ( CModuleInfo* pInfo );

	void StartAnalysisProcess ( CSourceFilePin* pSourceFilePin );
	void StopAnalysisProcess();

	inline void Begin()
	{
		m_iterModuleList = m_listModule.begin();
	}

	inline bool IsEnd()
	{
		return m_iterModuleList == m_listModule.end();
	}

	inline void NextIterator()
	{
		m_iterModuleList++;
	}

	inline CModuleInfo* GetIterator()
	{
		return (*m_iterModuleList);
	}

	inline CModuleGraph* GetModuleGraph()
	{
		return &m_ModuleGraph;
	}

public:
	CAnalysisNotifyInterface*		m_pOwnerInterface;
	char*							m_pszModuleDir;

	MODULE_ITER						m_iterModuleList;
	MODULE_LIST						m_listModule;
	CModuleGraph					m_ModuleGraph;
};

#endif // __ANALYSIS_MODULE_MANAGER_H__
