#include "MainFrame.h"
#include <iostream>	// TEST CODE
using namespace std;
#include "Main.h"

#define PROGRAM_TITLE		"Software Assurance"
#define	NEW_PROJECT_NAME	"New Project"
#define PROJECT_EXTENTION	".sap"
#define TITLE_EDITED		"(Edited)"

CMainFrame* g_pmfMainFrame;

CMainFrame::CMainFrame()
{
	g_pmfMainFrame = this;
	set_default_icon( render_icon( StockID( Stock::ABOUT ), ICON_SIZE_MENU ) );
	Reset();
	set_border_width( 5 );
	set_default_size( WINDOW_WIDTH, WINDOW_HEIGHT );

	add( m_vbwVBox );

	m_pActionGroup = ActionGroup::create();
	m_pActionGroup->add( Action::create( "FileMenu", "File" ) );
	m_pActionGroup->add( Action::create( "FileNewProject",    Stock::NEW,     "New Project"     ), sigc::mem_fun( *this, &CMainFrame::OnFileNewProject  ) );
	m_pActionGroup->add( Action::create( "FileSaveProject",	  Stock::SAVE,    "Save Project"    ), sigc::mem_fun( *this, &CMainFrame::OnFileSaveProject ) );
	m_pActionGroup->add( Action::create( "FileSaveAsProject", Stock::SAVE_AS, "Save As Project" ), sigc::mem_fun( *this, &CMainFrame::OnFileSaveAsProject ) );
	m_pActionGroup->add( Action::create( "FileLoadProject",   Stock::OPEN,	  "Open Project"    ), sigc::mem_fun( *this, &CMainFrame::OnFileOpenProject ) );
	m_pActionGroup->add( Action::create( "FileQuit",	      Stock::QUIT,    "Quit" ),		    sigc::mem_fun( *this, &CMainFrame::OnFileQuit ) );

	//m_pActionGroup->add( Action::create( "EditSomething", "Something"), AccelKey(" <control><alt>S "), sigc::mem_fun( *this, &ExampleWindow::on_menu_others ) );

	m_pActionGroup->add( Action::create( "ViewMenu", "View" ) );
	m_pActionGroup->add( Action::create( "ViewModuleGraph", Stock::CONVERT, "Module Graph" ), sigc::mem_fun( *this, &CMainFrame::OnViewModuleGraph  ) );

	m_pActionGroup->add( Action::create( "HelpMenu", "Help" ) );
	m_pActionGroup->add( Action::create( "HelpAbout", Stock::HELP, "About this" ), sigc::mem_fun( *this, &CMainFrame::OnHelpAbout ) );

	// Test Code

	m_pUIManager = UIManager::create();
	m_pUIManager->insert_action_group( m_pActionGroup );
	//add_accel_group( m_pUIManager->get_accel_group() );

	ustring strUIStructure = 
	"<ui>"
		"<menubar name='MenuBar'>"
			"<menu action='FileMenu'>"
				"<menuitem action='FileNewProject'/>"
				"<menuitem action='FileSaveProject'/>"
				"<menuitem action='FileSaveAsProject'/>"
				"<menuitem action='FileLoadProject'/>"
				"<separator/>"
				"<menuitem action='FileQuit'/>"
			"</menu>"
			"<menu action='ViewMenu'>"
				"<menuitem action='ViewModuleGraph'/>"
			"</menu>"
			"<menu action='HelpMenu'>"
				"<menuitem action='HelpAbout'/>"
			"</menu>"
		"</menubar>"
		"<toolbar  name='ToolBar'>"
			"<toolitem action='FileNewProject'/>"
			"<toolitem action='ViewModuleGraph'/>"
			"<toolitem action='FileQuit'/>"
		"</toolbar>"
	"</ui>";
	m_pUIManager->add_ui_from_string( strUIStructure );

	m_vbwVBox.pack_start( *( m_pUIManager->get_widget( "/MenuBar" ) ), PACK_SHRINK);
	m_vbwVBox.pack_start( *( m_pUIManager->get_widget( "/ToolBar" ) ), PACK_SHRINK);
	m_vbwVBox.pack_start( m_vpwVPaned );

	m_vpwVPaned.pack1( m_hpwHPaned );
	m_vpwVPaned.pack2( m_rvResultManager, false, false  );
	m_vpwVPaned.set_position( TAB_VIEW_HEIGHT );

	m_hpwHPaned.pack1( m_tvTabView, false, false );
	m_hpwHPaned.pack2( m_stvViewManager );
	m_hpwHPaned.set_position( TAB_VIEW_WIDTH );

	show_all_children();
}
CMainFrame::~CMainFrame()
{

}
void CMainFrame::OnViewModuleGraph()
{
	m_stvViewManager.AddModuleGraphView();
}
void CMainFrame::OnAddModule()
{
	//*
	CAnalysisResultPin a;
	a.m_nLineNo=10;
	a.m_pszErrorText = new char [100];
	strcpy( a.m_pszErrorText, "malloc Error" );
	a.m_pszFileName = new char [100];
	strcpy( a.m_pszFileName, "aaa.cpp" );
	m_rvResultManager.OnNotifyAnalysisResult( 1, &a );
	m_rvResultManager.OnNotifyAnalysisResult( 9, &a );
	a.m_nLineNo=23;
	strcpy( a.m_pszErrorText, "FILE stream close" );
	strcpy( a.m_pszFileName, "fff.cpp" );
	m_rvResultManager.OnNotifyAnalysisResult( 1, &a );

	m_rvResultManager.OnNotifyError( 3, 5, "  ջ" );
	//*/
	CNotifyProcessState b;
	b.m_uiModuleId = 1;
	b.m_pszText = new char [100];
	strcpy(b.m_pszText, "Processing...");
	m_rvResultManager.OnNotifyProcessState( &b );
}
bool CMainFrame::on_delete_event( GdkEventAny* geaEvent )
{
	if ( NewProject( false ) == false )
	{
		return true;
	}
	return Gtk::Window::on_delete_event( geaEvent );
}
bool CMainFrame::NewProject( bool bReset )
{
	if ( m_bModified == true )
	{
		MessageDialog msgDialog( "There is a project in process of construction.\nDo you save this project?", false, MESSAGE_INFO, BUTTONS_NONE );
		msgDialog.set_title( "Question" );
		msgDialog.add_button( Stock::YES, RESPONSE_YES );
		msgDialog.add_button( Stock::NO, RESPONSE_NO );
		msgDialog.add_button( Stock::CANCEL, RESPONSE_CANCEL );
		msgDialog.set_transient_for( *g_pmfMainFrame );
		int nResponse = msgDialog.run();
		cout << nResponse << endl;
		if ( nResponse == RESPONSE_YES )
		{
			OnFileSaveProject();
		}
		else if ( nResponse == RESPONSE_NO )
		{
			if ( bReset )
			{
				Reset();
			}
		}
		else
		{
			return false;
		}
	}
	else
	{
		if ( bReset )
		{
			Reset();
		}
	}
	return true;
}
void CMainFrame::OnFileNewProject()
{
	NewProject();
}
void CMainFrame::OnFileSaveProject()
{
	if ( m_pFileProject )
	{
		RefPtr< FileOutputStream > pFileOutputStream = m_pFileProject->replace();
		int nProjectNameLength = int( m_strProjectName.size() );
		pFileOutputStream->write( &nProjectNameLength, sizeof( nProjectNameLength ) );
		pFileOutputStream->write( m_strProjectName );
		m_tvTabView.SaveAs( pFileOutputStream );
		pFileOutputStream->close();
		SetModified( false );
	}
	else
	{
		OnFileSaveAsProject();
	}
}
void CMainFrame::OnFileSaveAsProject()
{
	FileChooserDialog fcdDialog( *this, "Save As Project", FILE_CHOOSER_ACTION_SAVE );
	fcdDialog.add_button( Stock::SAVE, RESPONSE_OK );
	fcdDialog.add_button( Stock::CANCEL, RESPONSE_CANCEL );
	FileFilter ffFilter;
	ffFilter.set_name( "Software Assurance Project File" );
	ffFilter.add_pattern( "*" PROJECT_EXTENTION );
	fcdDialog.add_filter( ffFilter );
	fcdDialog.property_do_overwrite_confirmation() = true;
	ustring strFileName;
	size_t sizeProjectExtention = strlen( PROJECT_EXTENTION );
	if ( fcdDialog.run() == RESPONSE_OK )
	{
		m_pFileProject.clear();
		strFileName = fcdDialog.get_filename();
		if ( strFileName.compare( strFileName.size() - sizeProjectExtention, sizeProjectExtention, PROJECT_EXTENTION ) != 0 )
		{
			strFileName += PROJECT_EXTENTION;
		}
		m_pFileProject = File::create_for_path( strFileName );
		OnFileSaveProject();
	}
}
void CMainFrame::OnFileOpenProject()
{
	if ( NewProject( false ) == false )
	{
		return;
	}

	FileChooserDialog fcdDialog( *this, "Open Project" );
	fcdDialog.add_button( Stock::OPEN, RESPONSE_OK );
	fcdDialog.add_button( Stock::CANCEL, RESPONSE_CANCEL );
	FileFilter ffFilter;
	ffFilter.set_name( "Software Assurance Project File" );
	ffFilter.add_pattern( "*" PROJECT_EXTENTION );
	fcdDialog.add_filter( ffFilter );
	ustring strFileName;
	RefPtr< File > pFile;
	if ( fcdDialog.run() == RESPONSE_OK )
	{
		Reset();
		strFileName = fcdDialog.get_filename();
		pFile = File::create_for_path( strFileName );
		RefPtr< FileInputStream > pFileInputStream = pFile->read();
		int nProjectNameLength;
		pFileInputStream->read( &nProjectNameLength, sizeof( nProjectNameLength ) );
		char* szProjectName = new char[ nProjectNameLength + 1 ];
		pFileInputStream->read( szProjectName, nProjectNameLength );
		szProjectName[ nProjectNameLength ] = 0;
		SetProjectName( szProjectName );
		delete [] szProjectName;
		m_tvTabView.Open( pFileInputStream );
		pFileInputStream->close();
		m_pFileProject = pFile;
		SetModified( false );
	}
}
void CMainFrame::OnFileQuit()
{
	if ( m_bModified == true )
	{
		if ( NewProject( false ) == true )
		{
			hide();	
		}
	}
	else
	{
		hide();
	}
}
void CMainFrame::OnHelpAbout()
{
	MessageDialog msgDialog(	"Software Assurance Beta Version\n\n"
								"DaeHun Yoo\n"
								"DaeMyoung Park\n"
								"JungMook Choi" );
	msgDialog.set_title( "About this" );
	msgDialog.set_transient_for( *g_pmfMainFrame );
	msgDialog.run();
}
void CMainFrame::SetProjectName( const ustring& strProjectName )
{
	m_strProjectName = strProjectName;
	set_title( PROGRAM_TITLE " - " + m_strProjectName );
	if ( m_bModified == true )
	{
		set_title( get_title() + " " TITLE_EDITED );
	}
	m_tvTabView.SetProjectName( m_strProjectName );
}
ustring CMainFrame::GetProjectName() const
{
	return m_strProjectName;
}
void CMainFrame::Reset()
{
	m_AnalysisModuleManager.GetModuleGraph()->Clear();
	if ( m_stvViewManager.GetModuleGraphView() )
	{
		m_stvViewManager.GetModuleGraphView()->Invalidate();
	}
	m_stvViewManager.OnCloseAllMenu();
	m_rvResultManager.Reset();
	SetProjectName( NEW_PROJECT_NAME );
	m_tvTabView.Reset();
	SetModified( false );
	m_pFileProject.clear();
}
bool CMainFrame::IsOpened( RefPtr< File > pFile )
{
	return m_stvViewManager.IsOpened( pFile );
}
bool CMainFrame::IsSelected( RefPtr< File > pFile )
{
	return m_stvViewManager.IsSelected( pFile );
}
void CMainFrame::SelectPage( RefPtr< File > pFile )
{
	m_stvViewManager.SelectPage( pFile );
}
void CMainFrame::SetModified( bool bModified )
{
	m_bModified = bModified;
	if ( m_bModified == true )
	{
		set_title( PROGRAM_TITLE " - " + m_strProjectName + " " TITLE_EDITED );
	}
	else
	{
		set_title( PROGRAM_TITLE " - " + m_strProjectName );
	}
}
bool CMainFrame::GetModified()
{
	return m_bModified;
}
CViewManager* CMainFrame::GetViewManager()
{
	return &m_stvViewManager;
}
CTabView* CMainFrame::GetTabView()
{
	return &m_tvTabView;
}
CAnalysisModuleManager* CMainFrame::GetAnalysisModuleManager()
{
	return &m_AnalysisModuleManager;
}
CModuleInfo* CMainFrame::FindNodeInfoInAMM( unsigned uiModuleID )
{
	for( m_AnalysisModuleManager.Begin(); m_AnalysisModuleManager.IsEnd() == false ; m_AnalysisModuleManager.NextIterator() )
	{
		if (m_AnalysisModuleManager.GetIterator()->m_uiId == uiModuleID )
		{
			return m_AnalysisModuleManager.GetIterator();
		}
	}
	return NULL;
}
char* CMainFrame::GetModuleName( unsigned uiModuleID )
{
	for( m_AnalysisModuleManager.Begin(); m_AnalysisModuleManager.IsEnd() == false ; m_AnalysisModuleManager.NextIterator() )
	{
		if (m_AnalysisModuleManager.GetIterator()->m_uiId == uiModuleID )
		{
			return m_AnalysisModuleManager.GetIterator()->m_szName;
		}
	}
	return NULL;
}

CResultManager* CMainFrame::GetResultManager()
{
	return &m_rvResultManager;
}


