#ifndef SWA_MAIN_FRAME_H
#define SWA_MAIN_FRAME_H
#include <gtkmm.h>
using namespace Gtk;
using namespace Glib;
#include <giomm.h>
using namespace Gio;
#include "TabView.h"
#include "ViewManager.h"
#include "ResultManager.h"
#include "AnalysisModuleManager.h"
class CNotebookLabel : public Gtk::HBox
{
public:
	CNotebookLabel( Glib::ustring strIconFileName, Glib::ustring strLabel,  Widget* pBaseWidget = NULL ,  int nSize = 0 ) : Gtk::HBox()
	{
		Gtk::Image* pImage = manage( new Gtk::Image );
		if ( strIconFileName == "File" )
		{
			pImage->set(render_icon( StockID( Stock::FILE ), ICON_SIZE_MENU ) );
		}
		else if ( strIconFileName == "Module" )
		{
			pImage->set( render_icon( StockID( Stock::CONVERT), ICON_SIZE_MENU ) );	
		}
		else
		{
			pImage->set( strIconFileName );	
		}
		pack_start( *pImage, false, false );
		Gtk::Label* pLabel = manage ( new Gtk::Label( strLabel ) );
		pLabel->set_size_request( nSize );
		pLabel->set_alignment( ALIGN_LEFT );
		pLabel->set_padding( 3, 0 );
		pack_start( *pLabel );

		m_pBaseWidget = pBaseWidget;
		if ( m_pBaseWidget )
		{
			Button* pButton = manage( new Button );
			pButton->set_image( *manage( new Gtk::Image( render_icon( StockID( Stock::CLOSE ), ICON_SIZE_MENU ) ) ) );
			pButton->set_focus_on_click( false );				// Ŭ Ŀ 
			pButton->set_relief( RELIEF_NONE );					// ư ܰ 
			pButton->get_modifier_style()->set_xthickness( 0 );	// ư   
			pButton->get_modifier_style()->set_ythickness( 0 );
			pButton->signal_clicked().connect( sigc::mem_fun( *this, &CNotebookLabel::OnCloseButtonClicked ) );
			pack_start( *pButton, false, false );
		}

		show_all_children();
	}
	void OnCloseButtonClicked()
	{
		m_pBaseWidget->hide();
		m_pBaseWidget->get_parent()->queue_draw();
	}
	Widget*		m_pBaseWidget;
};

class CMainFrame : public Gtk::Window
{
protected:
	VBox				m_vbwVBox;		// m_vpwVPaned, m_hbbwHButtonBox
	VPaned				m_vpwVPaned;	// m_hpwHPaned, Ʈ 
	HPaned				m_hpwHPaned;	//  , ҽ ؽƮ 
	CTabView			m_tvTabView;
	CViewManager		m_stvViewManager;
	CResultManager		m_rvResultManager;
	RefPtr<UIManager>	m_pUIManager;
	RefPtr<ActionGroup>	m_pActionGroup;
	ustring				m_strProjectName;
	bool				m_bModified;
	RefPtr< File >		m_pFileProject;

	CAnalysisModuleManager	m_AnalysisModuleManager;
public:
	CMainFrame();
	virtual ~CMainFrame();
	virtual void OnViewModuleGraph();
	virtual void OnAddModule();
	virtual bool on_delete_event( GdkEventAny* geaEvent );
	virtual bool NewProject( bool bReset = true );
	virtual void OnFileNewProject();
	virtual void OnFileSaveProject();
	virtual void OnFileSaveAsProject();
	virtual void OnFileOpenProject();
	virtual void OnFileQuit();
	virtual void OnHelpAbout();
	virtual void SetProjectName( const ustring& strProjectName );
	virtual ustring GetProjectName() const;
	virtual void Reset();
	virtual bool IsOpened( RefPtr< File > pFile );
	virtual bool IsSelected( RefPtr< File > pFile );
	virtual void SelectPage( RefPtr< File > pFile );
	virtual void SetModified( bool bModified = true );
	virtual bool GetModified();
	virtual CViewManager* GetViewManager();
	CTabView* GetTabView();

	CAnalysisModuleManager* GetAnalysisModuleManager();
	CModuleInfo* FindNodeInfoInAMM( unsigned uiModuleID );
	char* GetModuleName( unsigned uiModuleID );

	CResultManager* GetResultManager();
};
extern CMainFrame* g_pmfMainFrame;
#endif


