#include "ModuleFileTree.h"
#include <iostream>	// TEST CODE
#include <list>
using namespace std;
#include "MainFrame.h"
#include "ModuleGraphView.h"
CModuleFileTree::CModuleFileTree():
TreeView()
{
	m_ptsTreeModel		= TreeStore::create( m_tmcColumns );
	m_ptsTreeSelection	= get_selection();

	set_model( m_ptsTreeModel );
	//set_reorderable();

	//append_column_editable( "", m_tmcColumns.m_colName );
	//append_column( "", m_tmcColumns.m_colName );
	///*
	//CellRenderer* pCellRenderer = dynamic_cast< CellRenderer* >( get_column_cell_renderer( 0 ) );
	//pcrtRenderer->signal_editing_started().connect( sigc::mem_fun( *this, &CSourceFileTree::OnCellEditingStarted ) );
	//pcrtRenderer->signal_edited().connect( sigc::mem_fun( *this, &CSourceFileTree::OnCellEdited ) );
	//*/

	Gtk::TreeView::Column* pColumn = Gtk::manage( new Gtk::TreeView::Column( "" ) );
	pColumn->pack_start( m_tmcColumns.m_colIcon, false );
	pColumn->pack_start( m_CellRendererText  );
	append_column( *pColumn );
	pColumn->set_cell_data_func( m_CellRendererText, sigc::mem_fun( *this, &CModuleFileTree::cell_data_func ) );

	//enable_model_drag_source( Gdk::SHIFT_MASK );// | Gdk::MODIFIER_MASK );
	std::list<Gtk::TargetEntry> listTargets;
	listTargets.push_back( Gtk::TargetEntry("STRING") );
	listTargets.push_back( Gtk::TargetEntry("text/plain") );
	
	//enable_model_drag_source( listTargets, Gdk::SHIFT_MASK | Gdk::MODIFIER_MASK ); // | Gdk::MODIFIER_MASK );
	drag_source_set(listTargets, Gdk::MODIFIER_MASK );//, Gdk::ACTION_PRIVATE);

	set_rubber_banding();
	set_enable_tree_lines();

	set_headers_visible( false );
	m_ptsTreeSelection->set_mode( SELECTION_MULTIPLE );

	show_all_children();
}
CModuleFileTree::~CModuleFileTree()
{

}
void CModuleFileTree::cell_data_func( Gtk::CellRenderer* renderer, const Gtk::TreeModel::iterator& iter )
{
	if(iter)
	{
		Gtk::TreeModel::Row row = *iter;
		m_CellRendererText.property_text() = row[ m_tmcColumns.m_colName ];
	}
}
void CModuleFileTree::SetProjectName( const ustring& strProjectName )
{
	TreeNodeChildren::iterator itRoot = m_ptsTreeModel->children().begin();
	if ( itRoot )
	{
		itRoot->set_value( m_tmcColumns.m_colName, strProjectName );
	}
}
void CModuleFileTree::Reset()
{
	cout << "Reset 1" << endl;
	//m_ptsTreeModel->foreach_iter( sigc::mem_fun( *this, &CModuleFileTree::DeleteAllItem ) );
	m_ptsTreeModel->clear();
	TreeModel::Row tmRow = *( m_ptsTreeModel->append() );
	tmRow[ m_tmcColumns.m_colItemType ] = MFT_ITEM_TYPE_PROJECT;
	tmRow[ m_tmcColumns.m_colName	  ] = g_pmfMainFrame->GetProjectName();
	tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::SELECT_ALL ), Gtk::ICON_SIZE_MENU);
	cout << "Reset 2" << endl;
}
bool CModuleFileTree::DeleteAllItem( const TreeModel::iterator& itTreeModel )
{
	m_ptsTreeModel->erase( itTreeModel );
	return false;	
}
bool CModuleFileTree::on_button_release_event( GdkEventButton* pebEventButton )
{
	if ( pebEventButton->button == 3 )
	{
		Menu::MenuList& mlMenuList = m_mwPopupMenu.items();
		mlMenuList.clear();
		mlMenuList.push_back( Menu_Helpers::MenuElem( "Reload", sigc::mem_fun( *this, &CModuleFileTree::OnMenuReload ) ) );

		if ( mlMenuList.size() > 0 )
		{
			m_mwPopupMenu.popup( pebEventButton->button, pebEventButton->time );
		}
	}
	return TreeView::on_button_release_event( pebEventButton );
}
void CModuleFileTree::on_row_activated( const TreeModel::Path& tmPath, TreeViewColumn* ptvColumn )
{
	CAnalysisModuleManager* pAnalysisModuleManager = g_pmfMainFrame->GetAnalysisModuleManager();
	TreeModel::Row tmRow = *( m_ptsTreeModel->get_iter( tmPath ) );
	if ( tmRow[ m_tmcColumns.m_colItemType ] == MFT_ITEM_TYPE_FILE )
	{
		//  ׷ 信 ߰
		CModuleGraphView* pModuleGraphView = g_pmfMainFrame->GetViewManager()->GetModuleGraphView();
		if( pModuleGraphView )
		{
			for( pAnalysisModuleManager->Begin() ; pAnalysisModuleManager->IsEnd() == false ; pAnalysisModuleManager->NextIterator() )
			{
				if ( pAnalysisModuleManager->GetIterator()->m_uiId == tmRow[ m_tmcColumns.m_colID ] )
				{
					pModuleGraphView->AddModule( pAnalysisModuleManager->GetIterator() );
					break;
				}
			}
		}
	}
	TreeView::on_row_activated( tmPath, ptvColumn );
}
void CModuleFileTree::OnMenuReload()
{
	g_pmfMainFrame->SetModified();
	cout << "Reload()" << endl;
	Reset();
	CAnalysisModuleManager* pAnalysisModuleManager = g_pmfMainFrame->GetAnalysisModuleManager();
	pAnalysisModuleManager->UnloadModules();

	cout << "LoadModules Start" << endl;

	pAnalysisModuleManager->LoadModules();

	cout << "LoadModules End" << endl;

	TreeModel::iterator itRow;
	TreeModel::iterator itRowChild;
	stringstream strsName;
	TreeModel::Row tmRow;
	for( pAnalysisModuleManager->Begin() ; pAnalysisModuleManager->IsEnd() == false ; pAnalysisModuleManager->NextIterator() )
	{
		itRow = m_ptsTreeModel->append( m_ptsTreeModel->children().begin()->children() );
		itRow->set_value( m_tmcColumns.m_colItemType, int( MFT_ITEM_TYPE_FILE ) );
		itRow->set_value( m_tmcColumns.m_colName, ustring( pAnalysisModuleManager->GetIterator()->m_szModuleFileName ) );
		itRow->set_value( m_tmcColumns.m_colID, int( pAnalysisModuleManager->GetIterator()->m_uiId ) );
		tmRow = *itRow;
		tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::EXECUTE ), Gtk::ICON_SIZE_MENU);

		strsName.str("");
		strsName << "[ Module ] " << pAnalysisModuleManager->GetIterator()->m_szName << " : " << pAnalysisModuleManager->GetIterator()->m_uiId;
		itRowChild = m_ptsTreeModel->append( itRow->children() );
		itRowChild->set_value( m_tmcColumns.m_colItemType, int( MFT_ITEM_TYPE_INFO ) );
		itRowChild->set_value( m_tmcColumns.m_colName, ustring( strsName.str() ) );
		tmRow = *itRowChild;
		tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::INFO ), Gtk::ICON_SIZE_MENU);

		strsName.str("");
		strsName << "[ Input ] " << pAnalysisModuleManager->GetIterator()->m_szInputName << " : " << pAnalysisModuleManager->GetIterator()->m_uiInputId;
		itRowChild = m_ptsTreeModel->append( itRow->children() );
		itRowChild->set_value( m_tmcColumns.m_colItemType, int( MFT_ITEM_TYPE_INFO ) );
		itRowChild->set_value( m_tmcColumns.m_colName, ustring( strsName.str() ) );
		tmRow = *itRowChild;
		tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::INFO ), Gtk::ICON_SIZE_MENU);

		strsName.str("");
		strsName << "[ Output ] " << pAnalysisModuleManager->GetIterator()->m_szOutputName << " : " << pAnalysisModuleManager->GetIterator()->m_uiOutputId;
		itRowChild = m_ptsTreeModel->append( itRow->children() );
		itRowChild->set_value( m_tmcColumns.m_colItemType, int( MFT_ITEM_TYPE_INFO ) );
		itRowChild->set_value( m_tmcColumns.m_colName, ustring( strsName.str() ) );
		tmRow = *itRowChild;
		tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::INFO ), Gtk::ICON_SIZE_MENU);

		strsName.str("");
		strsName << "[ Revision ] " << pAnalysisModuleManager->GetIterator()->m_uiRevisionNo;
		itRowChild = m_ptsTreeModel->append( itRow->children() );
		itRowChild->set_value( m_tmcColumns.m_colItemType, int( MFT_ITEM_TYPE_INFO ) );
		itRowChild->set_value( m_tmcColumns.m_colName, ustring( strsName.str() ) );
		tmRow = *itRowChild;
		tmRow[ m_tmcColumns.m_colIcon	  ] = render_icon( Gtk::StockID( Gtk::Stock::INFO ), Gtk::ICON_SIZE_MENU);
	}
	expand_row( TreeModel::Path( m_ptsTreeModel->children().begin() ), false );
}
void CModuleFileTree::on_drag_begin( const Glib::RefPtr<Gdk::DragContext>& context )
{

	vector<TreeModel::Path> vecPath = m_ptsTreeSelection->get_selected_rows();
	vector<TreeModel::Path>::const_iterator itPath;
	vector<TreeModel::Path>::const_iterator itPathEnd = vecPath.end();
	TreeModel::Row tmRow;
	m_vecModuleID.clear();
	for ( itPath = vecPath.begin() ; itPath != itPathEnd ; ++itPath )
	{
		tmRow	=	*( m_ptsTreeModel->get_iter( *itPath ) );
		if ( tmRow[ m_tmcColumns.m_colItemType ] == MFT_ITEM_TYPE_FILE )
		{
			m_vecModuleID.push_back( tmRow[ m_tmcColumns.m_colID ] );
		}
	}
	TreeView::on_drag_begin( context );
}
void CModuleFileTree::on_drag_data_get( const Glib::RefPtr<Gdk::DragContext>& context, Gtk::SelectionData& selection_data, guint info, guint time)
{
	cout << "CModuleFileTree::drag_data_get" << endl;

	// int format -> source dest  ϴ ID
	selection_data.set( selection_data.get_target(), 1, NULL, 0 );
	expand_row( TreeModel::Path( m_ptsTreeModel->children().begin() ), false );
	TreeView::on_drag_data_get( context, selection_data, info, time );
}
vector< int >* CModuleFileTree::GetSelectedModuleIDList()
{
	return &m_vecModuleID;
}


