#include "ModuleGraphView.h"
#include <cairomm/context.h>
//#include <cairomm/types.h>
#include <iostream>	// TEST CODE
using namespace std;
#define VK_DELETE         0x2E
#include "MainFrame.h"
#include "Main.h"

#define PIN_ID_LENGTH_MAX 10
#define PIN_ID_FONT_SIZE 10
#define PIN_ID_FONT_NAME "Tahoma"
#define MODULE_NAME_FONT_SIZE 14
#define MODULE_NAME_FONT_NAME "Tahoma"
#define MODULE_MARGIN 7
#define CLIENT_MARGIN 10
#define MODULE_DRAG_ALPHA 0.4

CModuleGraphView::CModuleGraphView():
DrawingArea()
{

	add_events(Gdk::BUTTON_PRESS_MASK);
	add_events(Gdk::BUTTON_RELEASE_MASK);
	add_events(Gdk::POINTER_MOTION_MASK);
	add_events(Gdk::KEY_PRESS_MASK);
	set_flags( get_flags() | Gtk::CAN_FOCUS );

/*
	int i;
	for ( i = 0 ; i < 300 ; ++i )
	{
		m_aModuleInfo[ i ].m_uiId = i+20;
		sprintf( m_aModuleInfo[ i ].m_szName, "Test%d", i+1 );
		m_aModuleInfo[ i ].m_uiInputId = IOP_USER+i/2;
		m_aModuleInfo[ i ].m_uiOutputId = IOP_USER+i/2+1;
		
	}
	m_aModuleInfo[ 0 ].m_uiInputId = IOP_SOURCE_FILES;
	m_aModuleInfo[ 0 ].m_uiOutputId = IOP_USER;
	strcpy( m_aModuleInfo[ 0 ].m_szOutputName, "TestOut" );
	
	m_aModuleInfo[ 1 ].m_uiInputId = IOP_USER;
	m_aModuleInfo[ 1 ].m_uiOutputId = IOP_USER + 1;
	strcpy( m_aModuleInfo[ 1 ].m_szInputName, "TestIn" );
	strcpy( m_aModuleInfo[ 1 ].m_szOutputName, "TestOut" );

	m_aModuleInfo[ 2 ].m_uiInputId = IOP_USER + 1;
	strcpy( m_aModuleInfo[ 2 ].m_szInputName, "TestIn" );
	m_aModuleInfo[ 2 ].m_uiOutputId = IOP_ANALYSIS_RESULT;
*/

	m_nState				= 0;
	m_pSelectedNode			= NULL;
	m_pPinOutHitNode		= NULL;
	m_pPinInHitNode			= NULL;
	m_pConnectionNode[0]	= NULL;
	m_pConnectionNode[1]	= NULL;
	m_bLButtonDown			= FALSE;
	m_pPinInHitNode = NULL;
	m_bMoveClickLeft = false;

	std::list<Gtk::TargetEntry> listTargets;
	listTargets.push_back( Gtk::TargetEntry("STRING") );
	listTargets.push_back( Gtk::TargetEntry("text/plain") );
	drag_dest_set(listTargets);
}
CModuleGraphView::~CModuleGraphView()
{
	
}

void CModuleGraphView::on_drag_data_received( const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, const Gtk::SelectionData& selection_data, guint info, guint time)
{
	cout << "CModuleGraphView::on_drag_data_received" << endl;
	if( selection_data.get_format() == 1 )
	{
		vector< int >* pvecModuleID = g_pmfMainFrame->GetTabView()->GetModuleFileTree()->GetSelectedModuleIDList();
		vector< int >::iterator it;
		vector< int >::iterator itEnd = pvecModuleID->end();
		int i;
		for ( i=0, it = pvecModuleID->begin() ; it != itEnd ; ++it, ++i )
		{
			//cout << *it << endl;	
			AddModule( *it, x + i*10, y + i*10 );
		}
	}
	DrawingArea::on_drag_data_received( context, x, y, selection_data, info, time );
}
/*
void CModuleGraphView::on_size_allocate( Gtk::Allocation& aAllocation )
{
	m_nClientWidth = aAllocation.get_width();
	m_nClientHeight = aAllocation.get_height();
	DrawingArea::on_size_allocate( aAllocation );
}
*/
bool CModuleGraphView::on_motion_notify_event( GdkEventMotion* pEvent )
{
	CPoint point;
	point.x = long( pEvent->x );
	point.y = long( pEvent->y );
	OnMouseMove( 0, point );
	return Gtk::DrawingArea::on_motion_notify_event( pEvent );
}
bool CModuleGraphView::on_button_press_event( GdkEventButton* pEvent )
{
	grab_focus();
	if ( pEvent->button == 1 )
	{
		//cout << "Left Clicked" << endl;
		CPoint point;
		point.x = long( pEvent->x );
		point.y = long( pEvent->y );
		OnLButtonDown( 0, point );
	}
	return Gtk::DrawingArea::on_button_press_event( pEvent );
}
bool CModuleGraphView::on_button_release_event( GdkEventButton* pEvent )
{
	if ( pEvent->button == 1 )
	{
		//cout << "Left Clicked release" << endl;
		CPoint point;
		point.x = long( pEvent->x );
		point.y = long( pEvent->y );
		OnLButtonUp( 0, point );
	}
	return Gtk::DrawingArea::on_button_release_event( pEvent );
}
bool CModuleGraphView::on_expose_event( GdkEventExpose* pEvent )
{
	Glib::RefPtr< Gdk::Window > pWindow = get_window();
	Cairo::RefPtr< Cairo::Context > pCairoContext = pWindow->create_cairo_context();
	//this->set_double_buffered( true );
	//pCairoContext->set_antialias( Cairo::ANTIALIAS_NONE );
	pCairoContext->rectangle( pEvent->area.x, pEvent->area.y, pEvent->area.width, pEvent->area.height );
	//cout << pEvent->area.x << ' ' << pEvent->area.y << ' ' << pEvent->area.width << ' ' << pEvent->area.height << endl;
	pCairoContext->clip();
	pCairoContext->save();
	pCairoContext->set_source_rgb( GDK_RGB( 255, 255, 255 ) );
	pCairoContext->paint();
	pCairoContext->restore();
	Draw( pCairoContext, Gdk::Rectangle( pEvent->area.x, pEvent->area.y, pEvent->area.width, pEvent->area.height ) );
	return DrawingArea::on_expose_event( pEvent );
}
void CModuleGraphView::on_realize()
{
	OnInitialUpdate();
	DrawingArea::on_realize();
}
bool CModuleGraphView::on_key_press_event( GdkEventKey* pEvent )
{
	if ( pEvent->keyval == GDK_Delete )
	{
		OnKeyDown( VK_DELETE, 0, 0 );
	}
	else if ( pEvent->keyval == GDK_End ) // TEST CODE
	{
		cout << "Press END" << endl;
		//OnButtonInsertModule();
	}
	return DrawingArea::on_key_press_event( pEvent );
}



void CModuleGraphView::OnInitialUpdate() 
{
	//CView::OnInitialUpdate();
	
	//  ó ȣǴ 
}

void CModuleGraphView::DrawModule ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , CModuleNode* pNode, bool bDrag )
{
	Cairo::TextExtents TextSizeModuleName;
	ustring strText = Glib::locale_to_utf8( pNode->m_pInfo->m_szName );
	pCairoContext->set_font_size( MODULE_NAME_FONT_SIZE );
	pCairoContext->get_text_extents( strText, TextSizeModuleName );

	//  ڽ

	CRect rcOutterBox ( pNode->m_nX , pNode->m_nY , pNode->GetRight() , pNode->GetBottom() );

	CRect rcModuleName = rcOutterBox;
	rcModuleName.DeflateRect( MODULE_MARGIN, MODULE_MARGIN );
	rcModuleName.bottom = int( double( rcModuleName.top ) + TextSizeModuleName.height + MODULE_MARGIN * 2 );

	// ----------------------------------------------------------

	Cairo::TextExtents TextSizePinIn;
	Glib::ustring strPinIDIn;
	if ( pNode->m_pInfo->m_uiInputId != IOP_SOURCE_FILES )
	{
		strPinIDIn = Glib::ustring::compose( "%1 : %2", pNode->m_pInfo->m_uiInputId, pNode->m_pInfo->m_szInputName );
	}
	else
	{
		strPinIDIn = "SOURCE";
	}
	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	pCairoContext->get_text_extents( strPinIDIn, TextSizePinIn );

	Cairo::TextExtents TextSizePinOut;
	Glib::ustring strPinIDOut;
	if ( pNode->m_pInfo->m_uiOutputId != IOP_ANALYSIS_RESULT )
	{
		strPinIDOut = Glib::ustring::compose( "%1 : %2", pNode->m_pInfo->m_szOutputName, pNode->m_pInfo->m_uiOutputId );
	}
	else
	{
		strPinIDOut = "RESULT";
	}
	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	pCairoContext->get_text_extents( strPinIDOut, TextSizePinOut );

	// ----------------------------------------------------------

	CRect rcPinIDIn = rcOutterBox;
	rcPinIDIn.DeflateRect( MODULE_MARGIN, MODULE_MARGIN );
	rcPinIDIn.top = rcModuleName.bottom + MODULE_MARGIN;
	rcPinIDIn.right = long( rcPinIDIn.left + TextSizePinIn.width + MODULE_MARGIN * 2 );

	CRect rcPinIDOut = rcOutterBox;
	rcPinIDOut.DeflateRect( MODULE_MARGIN, MODULE_MARGIN );
	rcPinIDOut.top = rcPinIDIn.top;
	//rcPinIDOut.left = rcPinIDIn.right + MODULE_MARGIN;
	rcPinIDOut.left = long( rcPinIDOut.right - ( TextSizePinOut.width + MODULE_MARGIN * 2 ) );

	
	//  ǲ 

	int nX , nY;
	pNode->GetInputPoint ( nX , nY );
	CRect rcInput ( nX , nY , nX , nY );
	rcInput.InflateRect ( PIN_TRACKER_MARGIN / 2 , PIN_TRACKER_MARGIN / 2 );

	
	//  ƿǲ 

	pNode->GetOutputPoint ( nX  , nY );
	CRect rcOutput ( nX , nY , nX , nY );
	rcOutput.InflateRect ( PIN_TRACKER_MARGIN / 2 , PIN_TRACKER_MARGIN / 2 );


//	pCairoContext->save();


	pCairoContext->set_antialias( Cairo::ANTIALIAS_NONE );
	pCairoContext->set_line_width( 1 );
	Cairo::RefPtr< Cairo::LinearGradient > pGradient;
	double fAlpha = 1.0;
	if ( bDrag == true )
	{
		fAlpha = MODULE_DRAG_ALPHA;
	}

	// Box Drawing Start ---------------------------------------------------------------------------------------

																		// ⺻ 
	COLORREF crLine			= RGB( 126, 126, 126 );
	COLORREF crBox			= RGB( 236, 236, 236 );
	COLORREF crInBoxUp		= RGB( 247, 247, 247 );
	COLORREF crInBoxDown	= RGB( 211, 211, 211 );

	
	if ( m_pSelectedNode == pNode )	
	{
		if ( pNode->m_nChildNodeCount > 0 || pNode->m_pParentNode )	// õǰ  ٸ  Ѵٸ
		{
			//ʷϻ
			crLine			= RGB(  74, 187, 106 );
			crBox			= RGB( 221, 255, 216 );
			crInBoxUp		= RGB( 247, 250, 255 );
			crInBoxDown		= RGB( 211, 242, 207 );
		}
		else														// õǾµ ٸ   ٸ
		{
			// Ķ
			crLine			= RGB(  74, 126, 187 );
			crBox			= RGB( 211, 236, 255 );
			crInBoxUp		= RGB( 247, 255, 250 );
			crInBoxDown		= RGB( 211, 227, 242 );	
		}
	}
	else if ( pNode->m_nChildNodeCount > 0 || pNode->m_pParentNode )	// õ ʾ ٸ   ִٸ
	{
		//
		crLine			= RGB( 192, 166,  92 );
		crBox			= RGB( 255, 255, 205 );
		crInBoxUp		= RGB( 255, 252, 216 );
		crInBoxDown		= RGB( 255, 226, 133 );
	
	}
	if ( bDrag == true )
	{
		if ( pNode->m_nChildNodeCount > 0 || pNode->m_pParentNode )		// 巡 ߿ ٸ  ִٸ
		{
			//ʷϻ
			crLine			= RGB(  74, 187, 106 );
			crBox			= RGB( 221, 255, 216 );
			crInBoxUp		= RGB( 247, 250, 255 );
			crInBoxDown		= RGB( 211, 242, 207 );
		}
		else															// 巡 ߿ ٸ   ٸ
		{
			// Ķ
			crLine			= RGB(  74, 126, 187 );
			crBox			= RGB( 211, 236, 255 );
			crInBoxUp		= RGB( 247, 255, 250 );
			crInBoxDown		= RGB( 211, 227, 242 );	
		}
	}

	pCairoContext->rectangle( rcOutterBox.left, rcOutterBox.top, rcOutterBox.Width(), rcOutterBox.Height() );
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( crBox ), GetGValue( crBox ), GetBValue( crBox ) ), fAlpha );
	pCairoContext->fill_preserve();
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( crLine ), GetGValue( crLine ), GetBValue( crLine ) ), fAlpha );
	pCairoContext->stroke();

	pCairoContext->rectangle( rcModuleName.left, rcModuleName.top, rcModuleName.Width(), rcModuleName.Height() );
	pGradient = Cairo::LinearGradient::create( 0, rcModuleName.top, 0, rcModuleName.bottom );
	pGradient->add_color_stop_rgba( 0, GDK_RGB( GetRValue( crInBoxUp ), GetGValue( crInBoxUp ), GetBValue( crInBoxUp ) ), fAlpha );
	pGradient->add_color_stop_rgba( 1, GDK_RGB( GetRValue( crInBoxDown ), GetGValue( crInBoxDown ), GetBValue( crInBoxDown ) ), fAlpha );
	pCairoContext->set_source( pGradient );
	pCairoContext->fill_preserve();
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( crLine ), GetGValue( crLine ), GetBValue( crLine ) ), fAlpha );
	pCairoContext->stroke();

	pCairoContext->rectangle( rcPinIDIn.left, rcPinIDIn.top, rcPinIDIn.Width(), rcPinIDIn.Height() );
	pGradient = Cairo::LinearGradient::create( 0, rcPinIDIn.top, 0, rcPinIDIn.bottom );
	pGradient->add_color_stop_rgba( 0, GDK_RGB( GetRValue( crInBoxUp ), GetGValue( crInBoxUp ), GetBValue( crInBoxUp ) ), fAlpha );
	pGradient->add_color_stop_rgba( 1, GDK_RGB( GetRValue( crInBoxDown ), GetGValue( crInBoxDown ), GetBValue( crInBoxDown ) ), fAlpha );
	pCairoContext->set_source( pGradient );
	pCairoContext->fill_preserve();
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( crLine ), GetGValue( crLine ), GetBValue( crLine ) ), fAlpha );
	pCairoContext->stroke();

	pCairoContext->rectangle( rcPinIDOut.left, rcPinIDOut.top, rcPinIDOut.Width(), rcPinIDOut.Height() );
	pGradient = Cairo::LinearGradient::create( 0, rcPinIDOut.top, 0, rcPinIDOut.bottom );
	pGradient->add_color_stop_rgba( 0, GDK_RGB( GetRValue( crInBoxUp ), GetGValue( crInBoxUp ), GetBValue( crInBoxUp ) ), fAlpha );
	pGradient->add_color_stop_rgba( 1, GDK_RGB( GetRValue( crInBoxDown ), GetGValue( crInBoxDown ), GetBValue( crInBoxDown ) ), fAlpha );
	pCairoContext->set_source( pGradient );
	pCairoContext->fill_preserve();
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( crLine ), GetGValue( crLine ), GetBValue( crLine ) ), fAlpha );
	pCairoContext->stroke();

	// Box Drawing End --------------------------------------------------------------------------------------------


	// Input Pin Drawing Start --------------------------------

	if ( pNode->m_pInfo->m_uiInputId != IOP_SOURCE_FILES )
	{
		pCairoContext->rectangle( rcInput.left, rcInput.top, rcInput.Width(), rcInput.Height() );
		pGradient = Cairo::LinearGradient::create( 0, rcInput.top, 0, rcInput.bottom );
		pGradient->add_color_stop_rgba( 0, GDK_RGB( 255, 225, 225 ), fAlpha );
		pGradient->add_color_stop_rgba( 1, GDK_RGB( 255, 109, 109 ), fAlpha );
		pCairoContext->set_source( pGradient );
		pCairoContext->fill_preserve();
		pCairoContext->set_source_rgba( GDK_RGB( 190, 75, 72 ), fAlpha );
		pCairoContext->stroke();
	}

	// Input Pin Drawing End --------------------------------


	// Output Pin Drawing Start -------------------------------

	if ( pNode->m_pInfo->m_uiOutputId != IOP_ANALYSIS_RESULT )
	{
		pCairoContext->rectangle( rcOutput.left, rcOutput.top, rcOutput.Width(), rcOutput.Height() );
		pGradient = Cairo::LinearGradient::create( 0, rcOutput.top, 0, rcOutput.bottom );
		pGradient->add_color_stop_rgba( 0, GDK_RGB( 255, 225, 225 ), fAlpha );
		pGradient->add_color_stop_rgba( 1, GDK_RGB( 255, 109, 109 ), fAlpha );
		pCairoContext->set_source( pGradient );
		pCairoContext->fill_preserve();
		pCairoContext->set_source_rgba( GDK_RGB( 190, 75, 72 ), fAlpha );
		pCairoContext->stroke();
	}

	// Output Pin Drawing End -------------------------------
	

	// Print Module Name Start --------------------------------

	pCairoContext->set_source_rgba( GDK_RGB( 0, 0, 0 ), fAlpha );
	string strName = Glib::locale_to_utf8( pNode->m_pInfo->m_szName );
	Cairo::TextExtents textExtents;
	pCairoContext->set_font_size( MODULE_NAME_FONT_SIZE );
	pCairoContext->get_text_extents( strName, textExtents );
	pCairoContext->move_to( ( rcModuleName.left + rcModuleName.right - textExtents.width ) / 2.0, ( rcModuleName.top + rcModuleName.bottom + textExtents.height ) / 2.0 );
	pCairoContext->show_text( strName );

	// Print Module Name End --------------------------------


	// Print Input Pin ID Start --------------------------------

	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	pCairoContext->move_to( rcPinIDIn.left + MODULE_MARGIN, ( rcPinIDIn.top + rcPinIDIn.bottom + TextSizePinIn.height ) / 2.0 );
	pCairoContext->show_text( strPinIDIn );
	
	// Print Input Pin ID End --------------------------------

	
	// Print Output Pin ID Start --------------------------------

	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	pCairoContext->move_to( rcPinIDOut.right - MODULE_MARGIN - TextSizePinOut.width, ( rcPinIDOut.top + rcPinIDOut.bottom + TextSizePinOut.height ) / 2.0 );
	pCairoContext->show_text( strPinIDOut );

	// Print Output Pin ID End --------------------------------

//	pCairoContext->stroke();
//	pCairoContext->restore();
}

void CModuleGraphView::DrawConnection ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , CModuleNode* pParentNode , CModuleNode* pChildNode, bool bDrag )
{
	int nWidth = 1;
	COLORREF rgb = RGB ( 0 , 0 , 0 );
	if ( m_pConnectionNode[0] == pParentNode && m_pConnectionNode[1] == pChildNode )
	{
		rgb = RGB ( 0 , 0 , 255 );
		nWidth = 2;
	}
	double fAlpha = 1.0;
	if ( bDrag == true )
	{
		fAlpha = MODULE_DRAG_ALPHA;
	}
	pCairoContext->set_antialias( Cairo::ANTIALIAS_DEFAULT );
	pCairoContext->set_source_rgba( GDK_RGB( GetRValue( rgb ), GetGValue( rgb ), GetBValue( rgb ) ), fAlpha );
	pCairoContext->set_line_width( 1 );

	int nInX , nInY , nOutX , nOutY;
	pParentNode->GetOutputPoint ( nOutX , nOutY );
	pChildNode->GetInputPoint ( nInX , nInY );

	DrawArrow ( pCairoContext , nOutX , nOutY , nInX , nInY );
}
/*
void CModuleGraphView::OnButtonInsertModule() 
{
	//CModuleListDlg aDlg;
	//aDlg.SetAnalysisModuleManager ( &m_Manager );
	//aDlg.DoModal();
	//g_pmfMainFrame->GetAnalysisModuleManager()->InsertModuleIntoGraph ( ... );
	
	 // TEST CODE
	
	//g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->FindNodeInList(0)->Move(100, 100);
	int i;
	for ( i = 0; i < 300 ; ++i )
	{
		AddModule( &m_aModuleInfo[ i ] );
	}
}
*/
/*
void CModuleGraphView::AddModule()
{
	static int i=0;
	if ( i == 300 ) return;
	AddModule( &m_aModuleInfo[ i ] );
	++i;
}
*/
void CModuleGraphView::AddModule( int nModuleID, int x, int y )
{
	CModuleGraph* pModuleGraph = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph();
	if ( pModuleGraph == NULL )
	{
		return;
	}
	CModuleNode* pModuleNode = pModuleGraph->FindNodeInList( nModuleID );
	if ( pModuleNode )	// ̹  ׷ Ʈ ϵ ̶
	{
		return;			//   ߰  (ߺ ߰ )
	}
	CModuleInfo* pModuleInfo = g_pmfMainFrame->FindNodeInfoInAMM( nModuleID );

	int nMaxY = 0;
	if( x == -1 && y == -1 )
	{
		for ( pModuleGraph->Begin() ; pModuleGraph->IsEnd() == false ; pModuleGraph->NextIterator() )
		{
			nMaxY = max( nMaxY, pModuleGraph->GetIterator()->GetBottom() );
			//   ׷ Ʈ ϵ  ߿  Ʒ ġ ִ  Bottom  
		}
		cout << nMaxY << endl;
	}

	// m_Manager ߰    m_Manager  ƴ϶ g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()  	

	g_pmfMainFrame->GetAnalysisModuleManager()->InsertModuleIntoGraph( pModuleInfo );						//  ׷ Ʈ   ߰
	pModuleNode = pModuleGraph->FindNodeInList( pModuleInfo->m_uiId );	//  ߰   
	if( x == -1 && y == -1 )
	{
		pModuleNode->Move( CLIENT_MARGIN, nMaxY + CLIENT_MARGIN );			//  ߰   Ʒ ġ Ŵ
	}

	
	
	Cairo::RefPtr< Cairo::Context > pCairoContext = get_window()->create_cairo_context();

	//  ̸ κ     --------------------------------------------------

	Cairo::TextExtents TextSizeModuleName;
	pCairoContext->set_font_size( MODULE_NAME_FONT_SIZE );
	pCairoContext->get_text_extents( Glib::locale_to_utf8( pModuleInfo->m_szName ), TextSizeModuleName );
	double fPartWidthModuleName = TextSizeModuleName.width + MODULE_MARGIN * 4;
	
	//  ̸ κ     --------------------------------------------------


	//  ̵ κ     --------------------------------------------------

	Cairo::TextExtents TextSizePinIDIn;
	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	stringstream strPinIDIn;
	if ( pModuleNode->m_pInfo->m_uiInputId == IOP_SOURCE_FILES )
	{
		strPinIDIn << "SOURCE";
	}
	else
	{
		strPinIDIn << pModuleNode->m_pInfo->m_uiInputId << " : " << pModuleNode->m_pInfo->m_szInputName;
	}
	pCairoContext->get_text_extents( Glib::locale_to_utf8( strPinIDIn.str() ), TextSizePinIDIn );
	double fPartWidthPinIDIn = TextSizePinIDIn.width + MODULE_MARGIN * 2;

	Cairo::TextExtents TextSizePinIDOut;
	pCairoContext->set_font_size( PIN_ID_FONT_SIZE );
	stringstream strPinIDOut;
	if ( pModuleNode->m_pInfo->m_uiOutputId == IOP_ANALYSIS_RESULT )
	{
		strPinIDOut << "RESULT";
	}
	else
	{
		strPinIDOut << pModuleNode->m_pInfo->m_szOutputName << " : " << pModuleNode->m_pInfo->m_uiOutputId;
	}
	pCairoContext->get_text_extents( Glib::locale_to_utf8( strPinIDOut.str() ), TextSizePinIDOut );
	double fPartWidthPinIDOut = TextSizePinIDOut.width + MODULE_MARGIN * 2;

	double fPartWidthPinID = fPartWidthPinIDIn + fPartWidthPinIDOut + MODULE_MARGIN * 3;
	
	//  ̵ κ     --------------------------------------------------

	
	//  ũ⸦ Ͽ   -----------------------------------------------

	int nModuleWidth = int( max( fPartWidthModuleName, fPartWidthPinID ) );
	int nModuleHeight = int( TextSizeModuleName.height + TextSizePinIDIn.height + MODULE_MARGIN * 7 );
	pModuleNode->SetSize( nModuleWidth, nModuleHeight );

	//  ũ⸦ Ͽ   -----------------------------------------------

	// ߰  κ ȿ  ũ ּ 

	if( x != -1 || y != -1 )
	{
		x = max( x - nModuleWidth/2, CLIENT_MARGIN );
		y = max( y - nModuleHeight/2, CLIENT_MARGIN );
		pModuleNode->Move( x, y );			//  ߰   Ʒ ġ Ŵ
	}

	AdjustClientSize();		// Ŭ̾Ʈ ũ 
}
void CModuleGraphView::AddModule( int nModuleID )
{
	AddModule( nModuleID, -1, -1 );
}
void CModuleGraphView::AddModule( CModuleInfo* pModuleInfo )
{
	if ( pModuleInfo == NULL )
	{
		return;
	}

	AddModule( pModuleInfo->m_uiId );
}
void CModuleGraphView::AdjustClientSize()
{
	CModuleGraph* pModuleGraph = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph();
	if ( pModuleGraph == NULL )
	{
		return;
	}

	int nMaxX = 0;
	int nMaxY = 0;
	for ( pModuleGraph->Begin() ; pModuleGraph->IsEnd() == false ; pModuleGraph->NextIterator() )
	{
		nMaxX = max( nMaxX, pModuleGraph->GetIterator()->GetRight() );
		nMaxY = max( nMaxY, pModuleGraph->GetIterator()->GetBottom() );
	}
	set_size_request( nMaxX + 10, nMaxY + 10 );

	Invalidate();
}

void CModuleGraphView::DrawArrow ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , int nStX  ,int nStY , int nEdX , int nEdY )
{
	if( nStX == nEdX && nStY == nEdY )    return;
	
	// ߽ɼ ׸  -------------------

	pCairoContext->move_to( nStX, nStY );
	pCairoContext->line_to( nEdX, nEdY );
	pCairoContext->stroke();

	// ߽ɼ ׸  -------------------
	

	//  (ȭǥ Ӹ) ׸  -------------------

	pCairoContext->save();
	pCairoContext->translate( nEdX, nEdY );
	pCairoContext->rotate( atan2( double( nEdY - nStY ), double( nEdX - nStX ) ) );
	pCairoContext->move_to( 0, 0 );
	pCairoContext->line_to( -14, -5 );
	pCairoContext->line_to( -14, 5 );
	pCairoContext->close_path();
	pCairoContext->stroke_preserve();
	pCairoContext->fill();
	pCairoContext->restore();

	//  (ȭǥ Ӹ) ׸  -------------------
}

//   ׸ Լ
void CModuleGraphView::Draw ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext, const Gdk::Rectangle& rcClipArea )
{
	m_nState = 0;

//	g_pmfMainFrame->GetAnalysisModuleManager()->TrackingInGraph ( this );

	CModuleNode* pNode = NULL;
	CModuleGraph* pGraph = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph();

	//  ڽ    ---------------------------------------------

	Gdk::Rectangle rcModuleBox;
	bool bIntersect;
	for ( pGraph->Begin() ; false == pGraph->IsEnd() ; pGraph->NextIterator() )
	{
		pNode = pGraph->GetIterator();
		rcModuleBox = Gdk::Rectangle( pNode->m_nX - PIN_TRACKER_MARGIN / 2, pNode->m_nY, pNode->m_nWidth + PIN_TRACKER_MARGIN + 1, pNode->m_nHeight + 1 );
		rcModuleBox.intersect( rcClipArea, bIntersect );
		if ( pNode && bIntersect )
		{			
			DrawModule ( pCairoContext , pNode );
		}
	}

	//  ڽ    --------------------------------------------
	

	// ⿡  ȭǥ    -----------------------------------

	for ( pGraph->Begin() ; false == pGraph->IsEnd() ; pGraph->NextIterator() )
	{
		pNode = pGraph->GetIterator();
		if ( pNode )
		{			
			if ( pNode->m_nChildNodeCount > 0 )
			{
				for ( int i = 0 ; i < pNode->m_nChildNodeCount ; i++ )
				{
					DrawConnection ( pCairoContext , pNode , pNode->m_ppChildNodes[i] );
				}
			}
		}
	}

	// ⿡  ȭǥ    --------------------------------------

	
	// 巡   纻  

	if ( m_bMoveClickLeft )
	{
		//cout << "as" << endl;
		DrawModule ( pCairoContext , &m_ModuleNodeDrag, true );
		
		if ( m_ModuleNodeDrag.m_pParentNode )
		{
			DrawConnection ( pCairoContext , m_ModuleNodeDrag.m_pParentNode , &m_ModuleNodeDrag, true );
		}

		if ( m_ModuleNodeDrag.m_nChildNodeCount > 0 )
		{
			for ( int i = 0 ; i < m_ModuleNodeDrag.m_nChildNodeCount ; i++ )
			{
				DrawConnection ( pCairoContext , &m_ModuleNodeDrag , m_ppChildNodes[i], true );
			}
		}
	}

	// 巡   纻  


	//  巡  ȭǥ   ---------------------------------------

	//*
	if ( m_pPinOutHitNode )
	{	
		int nX , nY;
		m_pPinOutHitNode->GetOutputPoint ( nX , nY );

		//pCairoContext->save();
		pCairoContext->set_line_width( 1 );
		pCairoContext->set_antialias( Cairo::ANTIALIAS_DEFAULT );
		if ( m_pPinInHitNode )
		{
			pCairoContext->set_source_rgb( 1.0, 0.0, 0.0 );
		}
		else
		{
			pCairoContext->set_source_rgb( 0.0, 0.0, 0.0 );
		}
		

		DrawArrow ( pCairoContext , nX , nY , m_ptMouseMove.x , m_ptMouseMove.y );

		//pCairoContext->restore();
	}
	//*/

	//  巡  ȭǥ   --------------------------------------
}

void CModuleGraphView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//SetCapture();
	m_bLButtonDown = TRUE;
	m_ptMouseMove = m_ptMove = point;
	
	bool bPinIn;
	CModuleNode* pTempNode = NULL;
	if ( pTempNode = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->PinHitTest ( point.x , point.y , bPinIn ) )
	{
		if ( false == bPinIn )
		{
			if ( pTempNode->m_pInfo->m_uiOutputId != IOP_ANALYSIS_RESULT )
			{
				m_pPinOutHitNode		= pTempNode;
				m_pConnectionNode[0]	= NULL;
				m_pConnectionNode[1]	= NULL;
				m_pSelectedNode			= NULL;
				//return;
			}
		}
	}
	
	if ( !m_pPinOutHitNode )
	{
		m_pSelectedNode = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->HitTest ( point.x , point.y );
	}
		
	if ( m_pSelectedNode )
	{
		m_pConnectionNode[0] = NULL;
		m_pConnectionNode[1] = NULL;
		m_ptClickLeftBox = point - CPoint( m_pSelectedNode->m_nX, m_pSelectedNode->m_nY );
		// Ŭ    
		m_ModuleNodeDrag = *m_pSelectedNode;
		m_ppChildNodes = m_ModuleNodeDrag.m_ppChildNodes;
		m_ModuleNodeDrag.m_ppChildNodes = NULL;
	}
	else
	{
		bool bConnectionHit = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->ConnectionHitTest ( point.x , point.y , m_pConnectionNode[0] , m_pConnectionNode[1] );
		if ( bConnectionHit )
		{
		}
	}
	Invalidate();
}

void CModuleGraphView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if ( m_bLButtonDown == false )
	{
		return;
	}
	m_bLButtonDown = FALSE;
	if ( m_pPinOutHitNode )
	{
		//0xcdcdcdcd
		if ( m_pPinInHitNode )
		{
			bool bRet = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->ConnectModule ( m_pPinOutHitNode , m_pPinInHitNode );
			if ( false == bRet )
			{
				AfxMessageBox ( "Error : Failed to connect between pins (different pin Id)" );
			}
		}
		m_pPinOutHitNode	= NULL;
		m_pPinInHitNode		= NULL;
		Invalidate();
	}
	if ( m_pSelectedNode )
	{
		m_pSelectedNode->Move( point.x - m_ptClickLeftBox.x, point.y - m_ptClickLeftBox.y );
		m_pSelectedNode->m_nX = max( m_pSelectedNode->m_nX, CLIENT_MARGIN );
		m_pSelectedNode->m_nY = max( m_pSelectedNode->m_nY, CLIENT_MARGIN );
		AdjustClientSize();
		m_bMoveClickLeft = false;
//		m_pSelectedNode		= NULL;
		//memset( &m_ModuleNodeDrag, 0, sizeof( m_ModuleNodeDrag ) );
		
	}

	if ( m_pConnectionNode[0] )
	{
//		m_pConnectionNode[0] = NULL;
//		m_pConnectionNode[1] = NULL;
	}
}

void CModuleGraphView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CPoint pt = point - m_ptMove;

	if ( m_bLButtonDown )
	{
		if ( m_pPinOutHitNode )
		{
			m_ptMouseMove = point;
			bool bPinIn;
			CModuleNode* pTempNode = NULL;
			if ( pTempNode = g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->PinHitTest ( point.x , point.y , bPinIn ) )
			{
				if ( bPinIn )
				{
					if ( pTempNode->m_pInfo->m_uiInputId != IOP_SOURCE_FILES )
					{
						m_pPinInHitNode = pTempNode;
					}
				}
			}
			if ( NULL == pTempNode )
			{
				m_pPinInHitNode = NULL;
			}

			Gdk::Region RefreshRegion;
			//Gdk::Rectangle a;
			
			m_pPinOutHitNode->m_nX;
			m_pPinOutHitNode->m_nY;

			
			//*
			CRect rcArrowPrev( m_ptMove.x, m_ptMove.y, m_ptMove.x, m_ptMove.y );
			rcArrowPrev.InflateRect( 16, 16 );
			CRect rcArrowNow( point.x, point.y, point.x, point.y );
			rcArrowNow.InflateRect( 16, 16 );
			//*/
			int nX;
			int nY;
			m_pPinOutHitNode->GetOutputPoint( nX, nY );
			CRect rcLinePrev( min( int( m_ptMove.x ), nX ), min( int( m_ptMove.y ), nY ), max( int( m_ptMove.x ), nX ), max( int( m_ptMove.y ), nY ) );
			CRect rcLineNow( min( int( point.x ), nX ), min( int( point.y ), nY ), max( int( point.x ), nX ), max( int( point.y ), nY ) );
			rcLinePrev.InflateRect( 1, 1 );
			rcLineNow.InflateRect( 1, 1 );
			RefreshRegion.union_with_rect( Gdk::Rectangle( rcLinePrev.left, rcLinePrev.top, rcLinePrev.Width(), rcLinePrev.Height() ) );
			RefreshRegion.union_with_rect( Gdk::Rectangle( rcLineNow.left, rcLineNow.top, rcLineNow.Width(), rcLineNow.Height() ) );

			RefreshRegion.union_with_rect( Gdk::Rectangle( rcArrowPrev.left, rcArrowPrev.top, rcArrowPrev.Width(), rcArrowPrev.Height() ) );
			RefreshRegion.union_with_rect( Gdk::Rectangle( rcArrowNow.left, rcArrowNow.top, rcArrowNow.Width(), rcArrowNow.Height() ) );

			
			Gdk::Rectangle r;
			RefreshRegion.get_clipbox(r);
			//cout << r.get_x() << ' ' << r.get_y() << ' ' << r.get_width() << ' ' << r.get_height() << endl;
			get_window()->invalidate_region( RefreshRegion, false );
			//Invalidate();// Rect 
		}
		else if ( m_pSelectedNode )
		{
			m_bMoveClickLeft = true;
			
			int nOldInputX;
			int nOldInputY;
			m_ModuleNodeDrag.GetInputPoint( nOldInputX, nOldInputY );
			int nOldOutputX;
			int nOldOutputY;
			m_ModuleNodeDrag.GetOutputPoint( nOldOutputX, nOldOutputY );


			m_ModuleNodeDrag.Move( point.x - m_ptClickLeftBox.x, point.y - m_ptClickLeftBox.y );
			m_ModuleNodeDrag.m_nX = max( m_ModuleNodeDrag.m_nX, 10 );
			m_ModuleNodeDrag.m_nY = max( m_ModuleNodeDrag.m_nY, 10 );

			int nNewInputX;
			int nNewInputY;
			m_ModuleNodeDrag.GetInputPoint( nNewInputX, nNewInputY );

			int nNewOutputX;
			int nNewOutputY;
			m_ModuleNodeDrag.GetOutputPoint( nNewOutputX, nNewOutputY );

			Gdk::Region RefreshRegion;
			RefreshRegion.union_with_rect( Gdk::Rectangle( max( int(m_ptMove.x - m_ptClickLeftBox.x - PIN_TRACKER_MARGIN / 2), 10  - PIN_TRACKER_MARGIN / 2 ) - 2, max( int( m_ptMove.y - m_ptClickLeftBox.y ), 10 ) - 2, m_ModuleNodeDrag.m_nWidth + PIN_TRACKER_MARGIN + 3, m_ModuleNodeDrag.m_nHeight + 3 ) );
			RefreshRegion.union_with_rect( Gdk::Rectangle( max( int(point.x - m_ptClickLeftBox.x - PIN_TRACKER_MARGIN / 2), 10  - PIN_TRACKER_MARGIN / 2 ) - 2, max( int( point.y - m_ptClickLeftBox.y ), 10 ) - 2, m_ModuleNodeDrag.m_nWidth + PIN_TRACKER_MARGIN + 3, m_ModuleNodeDrag.m_nHeight + 3) );

			if ( m_pSelectedNode->m_pParentNode )
			{
				int nX;
				int nY;
				m_pSelectedNode->m_pParentNode->GetOutputPoint( nX, nY );
				

				CRect rcArrowPrev( nOldInputX, nOldInputY, nOldInputX, nOldInputY );
				rcArrowPrev.InflateRect( 16, 16 );
				CRect rcArrowNow( nNewInputX, nNewInputY, nNewInputX, nNewInputY );
				rcArrowNow.InflateRect( 16, 16 );


				CRect rcLinePrev( min( nOldInputX, nX ), min( nOldInputY, nY ), max( nOldInputX, nX ), max( nOldInputY, nY ) );
				CRect rcLineNow( min( nNewInputX, nX ), min( nNewInputY, nY ), max( nNewInputX, nX ), max( nNewInputY, nY ) );
				rcLinePrev.InflateRect( 1, 1 );
				rcLineNow.InflateRect( 1, 1 );

				Gdk::Region RefreshRegionParent;
				RefreshRegionParent.union_with_rect( Gdk::Rectangle( rcLinePrev.left, rcLinePrev.top, rcLinePrev.Width(), rcLinePrev.Height() ) );
				RefreshRegionParent.union_with_rect( Gdk::Rectangle( rcLineNow.left, rcLineNow.top, rcLineNow.Width(), rcLineNow.Height() ) );

				RefreshRegionParent.union_with_rect( Gdk::Rectangle( rcArrowPrev.left, rcArrowPrev.top, rcArrowPrev.Width(), rcArrowPrev.Height() ) );
				RefreshRegionParent.union_with_rect( Gdk::Rectangle( rcArrowNow.left, rcArrowNow.top, rcArrowNow.Width(), rcArrowNow.Height() ) );

				RefreshRegion.union_( RefreshRegionParent );

			}

			if ( m_pSelectedNode->m_nChildNodeCount > 0 )
			{
				int nInputX;
				int nInputY;
				CRect rcArrow;
				Gdk::Region RefreshRegionChild;
				CRect rcLinePrev;
				CRect rcLineNow;
				for ( int i = 0 ; i < m_pSelectedNode->m_nChildNodeCount ; i++ )
				{
					m_ppChildNodes[i]->GetInputPoint( nInputX, nInputY );
					rcArrow = CRect( nInputX, nInputY, nInputX, nInputY );
					rcArrow.InflateRect( 16, 16 );
					RefreshRegionChild.union_with_rect( Gdk::Rectangle( rcArrow.left, rcArrow.top, rcArrow.Width(), rcArrow.Height() ) );

					rcLinePrev = CRect ( min( nOldOutputX, nInputX ), min( nOldOutputY, nInputY ), max( nOldOutputX, nInputX ), max( nOldOutputY, nInputY ) );
					rcLineNow = CRect ( min( nNewOutputX, nInputX ), min( nNewOutputY, nInputY ), max( nNewOutputX, nInputX ), max( nNewOutputY, nInputY ) );
					rcLinePrev.InflateRect( 1, 1 );
					rcLineNow.InflateRect( 1, 1 );

					RefreshRegionChild.union_with_rect( Gdk::Rectangle( rcLinePrev.left, rcLinePrev.top, rcLinePrev.Width(), rcLinePrev.Height() ) );
					RefreshRegionChild.union_with_rect( Gdk::Rectangle( rcLineNow.left, rcLineNow.top, rcLineNow.Width(), rcLineNow.Height() ) );

					//m_pSelectedNode->m_ppChildNodes
					//DrawConnection ( pCairoContext , &m_ModuleNodeDrag , m_ppChildNodes[i], true );
				}

				RefreshRegion.union_( RefreshRegionChild );
			}

			get_window()->invalidate_region( RefreshRegion, false ); //   ȿȭ   ȵǴ ..?
			//get_window()->invalidate( false );
		}
	}
	m_ptMove = point;
}

void CModuleGraphView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if ( nChar == VK_DELETE )
	{
		if ( m_pSelectedNode )
		{
			g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->RemoveNodeInList ( m_pSelectedNode );
			m_pSelectedNode = NULL;
			Invalidate();
		}	

		if ( m_pConnectionNode[0] )
		{
			g_pmfMainFrame->GetAnalysisModuleManager()->GetModuleGraph()->DisconnectModule ( m_pConnectionNode[0] , m_pConnectionNode[1] );
			m_pConnectionNode[0] = NULL;
			m_pConnectionNode[1] = NULL;
			Invalidate();
		}
	}
	AdjustClientSize();
}
void CModuleGraphView::Invalidate()
{
	Glib::RefPtr< Gdk::Window > pWindow = get_window();
	pWindow->invalidate_region ( pWindow->get_visible_region(), false );
}
void CModuleGraphView::AfxMessageBox( const char* pszText )
{
	MessageDialog msgDialog( pszText );
	msgDialog.set_title( "Error" );
	msgDialog.set_transient_for( *( (Gtk::Window*)get_toplevel() ) );
	msgDialog.run();
}


