#ifndef SWA_MODULE_GRAPH_VIEW_H
#define SWA_MODULE_GRAPH_VIEW_H
#include<gtkmm.h>
using namespace Gtk;
#include <cairomm/context.h>
//#include <cairomm/types.h>
#include <iostream>
using namespace std;
#include "AnalysisModuleManager.h"

class CPoint
{
public:
	long x;
	long y;
	CPoint()
	{
		x = 0;
		y = 0;
	}
	CPoint( long nX, long nY )
	{
		x = nX;
		y = nY;
	}
	const CPoint operator- ( const CPoint& point )
	{
		CPoint pointTmp;
		pointTmp.x = x - point.x;
		pointTmp.y = y - point.y;
		return pointTmp;
	}
};
typedef unsigned int UINT;
typedef int BOOL;
typedef unsigned char BYTE;
typedef unsigned long DWORD_PTR;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#define LOBYTE(w)           ((BYTE)(((DWORD_PTR)(w)) & 0xff))
#define RGB(r,g,b)          ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
#define GetRValue(rgb)      (LOBYTE(rgb))
#define GetGValue(rgb)      (LOBYTE(((WORD)(rgb)) >> 8))
#define GetBValue(rgb)      (LOBYTE((rgb)>>16))
typedef unsigned long COLORREF;

class CRect
{
public:
	long left;
	long top;
	long right;
	long bottom;
	CRect()
	{
		left = 0;
		top = 0;
		right = 0;
		bottom = 0;	
	}
	CRect(int l, int t, int r, int b)
	{
		left = l;
		top = t;
		right = r;
		bottom = b;	
	}
	int Width() const
	{
		return right - left;
	}
	int Height() const
	{
		return bottom - top;
	}
	void InflateRect(int x, int y)
	{
		left -= x;
		top -= x;
		right += y;
		bottom += y;
	}
	void DeflateRect(int x, int y)
	{
		left += x;
		top += x;
		right -= y;
		bottom -= y;
	}
};

class CModuleGraphView : public DrawingArea
{
public:
	CModuleGraphView();
	virtual ~CModuleGraphView();
	virtual void on_drag_data_received( const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, const Gtk::SelectionData& selection_data, guint info, guint time);
	//virtual void on_size_allocate( Gtk::Allocation& aAllocation );
	virtual bool on_motion_notify_event( GdkEventMotion* pEvent );
	void OnMouseMove(UINT nFlags, CPoint point);

	virtual bool on_button_press_event( GdkEventButton* pEvent );
	void OnLButtonDown(UINT nFlags, CPoint point);
	
	virtual bool on_button_release_event( GdkEventButton* pEvent );
	void OnLButtonUp(UINT nFlags, CPoint point);
	
	virtual bool on_expose_event( GdkEventExpose* pEvent );
	
	virtual void on_realize();
	void OnInitialUpdate();

	virtual bool on_key_press_event( GdkEventKey* pEvent );
	void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
protected:

	int			m_nState;
	
	BOOL		m_bPinInHit;
	BOOL		m_bPinOutHit;
	BOOL		m_bLButtonDown;

	CModuleNode*			m_pConnectionNode[2];

	CModuleNode*			m_pSelectedNode;
	CModuleNode*			m_pPinInHitNode;
	CModuleNode*			m_pPinOutHitNode;
	CPoint					m_ptMove;
	CPoint					m_ptMouseMove;
	CPoint					m_ptClickLeftBox;
	bool					m_bMoveClickLeft;
	CModuleNode				m_ModuleNodeDrag;
	CModuleNode**			m_ppChildNodes;
	CPoint					m_aArrow[3];

	//CModuleInfo m_aModuleInfo[ 300 ];  // TEST CODE
	
public:
	
	void Draw ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext, const Gdk::Rectangle& rcClipArea );
	void DrawModule ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , CModuleNode* pParentNode, bool bDrag = false );
	void DrawConnection ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , CModuleNode* pParentNode , CModuleNode* pChildNode, bool bDrag = false );
	void DrawArrow ( ::Cairo::RefPtr< ::Cairo::Context > pCairoContext , int nStX  ,int nStY , int nEdX , int nEdY );
	
	//void OnButtonInsertModule();
	void Invalidate();
	void AfxMessageBox( const char* pszText );
	//void AddModule();
	void AddModule( CModuleInfo* pModuleInfo );
	void AddModule( int nModuleID );
	void AddModule( int nModuleID, int x, int y );
	void AdjustClientSize();
};
#endif


