#include "ResultManager.h"
#include <iostream>	// TEST CODE
using namespace std;
#include "MainFrame.h"
// #define DEFAULT_MODULE_PATH "/SWALinuxSource/Module/"
#define DEFAULT_MODULE_PATH "/root/OSS/CVS/StaticAnalysisTool/SwALinuxSource/Module/"
CResultManager::CResultManager():
Notebook()
{
	Menu::MenuList& mlMenuList = m_mwPopupMenu.items();
	mlMenuList.push_back( Menu_Helpers::MenuElem( "_Close", sigc::mem_fun( *this, &CResultManager::OnCloseMenu ) ) );
	set_scrollable( true );
	
	append_page( m_ResultView, *( manage( new CNotebookLabel( "Image/ResultView.png", "Result", NULL, -1 ) ) ) );
	append_page( m_ProcessView, *( manage( new CNotebookLabel( "Image/ProcessView.png", "Process", NULL, -1 ) ) ) );
	append_page( m_ErrorView, *( manage( new CNotebookLabel( "Image//ErrorView.png", "Error", NULL, -1 ) ) ) );
	set_tab_pos( POS_BOTTOM );
	show_all_children();

	
}
CResultManager::~CResultManager()
{

}
void CResultManager::on_realize()
{
	g_pmfMainFrame->GetAnalysisModuleManager()->Initialize ( this , DEFAULT_MODULE_PATH );
	Notebook::on_realize();
}
void CResultManager::on_switch_page( GtkNotebookPage* pnpNotebookPage, guint uiPageNumber )
{
	Notebook::on_switch_page( pnpNotebookPage, uiPageNumber );
}
bool CResultManager::on_button_press_event( GdkEventButton* pebEventButton )
{
	pebEventButton->button = 1;
	return Notebook::on_button_press_event( pebEventButton );
}
bool CResultManager::on_button_release_event( GdkEventButton* pebEventButton )
{
	if( pebEventButton->button == 3 )
	{
		//m_mwPopupMenu.popup( pebEventButton->button, pebEventButton->time );
	}
	pebEventButton->button = 1;
	return Notebook::on_button_release_event( pebEventButton );
}

void CResultManager::OnCloseMenu()
{
	cout << "OnCloseMenu" << endl;
}

void CResultManager::AddPage()
{
	cout << "AddPage" << endl;
}

void CResultManager::OnNotifyError ( unsigned int uiModuleId , unsigned int uiErrorNo , char* pErrorText )
{
	m_ErrorView.OnNotifyError( uiModuleId, uiErrorNo, pErrorText );
}

void CResultManager::OnNotifyAnalysisResult ( unsigned int uiModuleId , CAnalysisResultPin* pAnalysisResultPin )
{
	printf( "In On NotifyAnalysisResult\n" );
	m_ResultView.OnNotifyAnalysisResult( uiModuleId, pAnalysisResultPin );
}

void CResultManager::OnNotifyProcessState ( CNotifyProcessState* pProcessState )
{
	m_ProcessView.OnNotifyProcessState( pProcessState );
}

CResultView* CResultManager::GetResultView()
{
	return &m_ResultView;
}

void CResultManager::Reset()
{
	m_ErrorView.Reset();
	m_ResultView.Reset();
	m_ProcessView.Reset();
}

