#ifndef SWA_RESULT_MANAGER_H
#define SWA_RESULT_MANAGER_H
#include <gtkmm.h>
using namespace Gtk;
#include <vector>
using namespace std;
#include "AnalysisModuleManager.h"
#include "ErrorView.h"
#include "ResultView.h"
#include "ProcessView.h"
class CResultManager : public Notebook, public CAnalysisNotifyInterface
{
protected:
	Menu m_mwPopupMenu;
	CErrorView m_ErrorView;
	CResultView m_ResultView;
	CProcessView m_ProcessView;

public:
	CResultManager();
	virtual ~CResultManager();
	virtual void on_realize();
	virtual void on_switch_page( GtkNotebookPage* pnpNotebookPage, guint uiPageNumber );
	virtual bool on_button_press_event( GdkEventButton* pebEventButton );
	virtual bool on_button_release_event( GdkEventButton* pebEventButton );
	virtual void OnCloseMenu();
	virtual void AddPage();

	virtual void OnNotifyError ( unsigned int uiModuleId , unsigned int uiErrorNo , char* pErrorText );
	virtual void OnNotifyAnalysisResult ( unsigned int uiModuleId , CAnalysisResultPin* pAnalysisResultPin );
	virtual void OnNotifyProcessState ( CNotifyProcessState* pProcessState );
	void Reset();

	CResultView* GetResultView();
};
#endif


