#include "TabView.h"
#include <iostream>		// TEST CODE
using namespace std;	// TEST CODE
#include "MainFrame.h"
CTabView::CTabView():
Notebook()
{
	Label* lwSourceFileTree = manage( new Label( "Source Explorer" ) );
	Label* lwModuleFileTree = manage( new Label( "Module Explorer" ) );
	lwSourceFileTree->set_size_request( 0 );
	lwModuleFileTree->set_size_request( 0 );
	lwSourceFileTree->set_alignment( ALIGN_LEFT );
	lwModuleFileTree->set_alignment( ALIGN_LEFT );
	m_swwSourceFileTree.add( m_twSourceFileTree );
	m_swwModuleFileTree.add( m_twModuleFileTree );
	m_swwSourceFileTree.set_policy( POLICY_AUTOMATIC, POLICY_AUTOMATIC );
	m_swwModuleFileTree.set_policy( POLICY_AUTOMATIC, POLICY_AUTOMATIC );
	//append_page( m_swwSourceFileTree, *lwSourceFileTree );
	append_page( m_swwSourceFileTree, *( manage( new CNotebookLabel( "Image/SourceFileTree.png", "Source Explorer" ) ) ) );
	append_page( m_swwModuleFileTree, *( manage( new CNotebookLabel( "Image/ModuleFileTree.png", "Module Explorer" ) ) ) );
	set_tab_label_packing( m_swwSourceFileTree, true, true, PACK_START );
	set_tab_label_packing( m_swwModuleFileTree, true, true, PACK_START );
	set_tab_reorderable( m_swwSourceFileTree );
	set_tab_reorderable( m_swwModuleFileTree );
	set_tab_pos( POS_BOTTOM );
	show_all_children();
}
CTabView::~CTabView()
{

}
void CTabView::on_switch_page( GtkNotebookPage* pnpNotebookPage, guint uiPageNumber )
{
	Notebook::on_switch_page( pnpNotebookPage, uiPageNumber );
}
void CTabView::Reset()
{
	m_twSourceFileTree.Reset();
	m_twModuleFileTree.Reset();
}
void CTabView::SetProjectName( const ustring& strProjectName )
{
	m_twSourceFileTree.SetProjectName( strProjectName );
	m_twModuleFileTree.SetProjectName( strProjectName );
}
void CTabView::SaveAs( RefPtr< FileOutputStream > pFileOutputStream )
{
	m_twSourceFileTree.SaveAs( pFileOutputStream );
}
void CTabView::Open( RefPtr< FileInputStream > pFileInputStream )
{
	m_twSourceFileTree.Open( pFileInputStream );
}
CModuleFileTree* CTabView::GetModuleFileTree()
{
	return &m_twModuleFileTree;
}


